#ifndef CORE_H
#define CORE_H

#include <gtk/gtk.h>
#include "cfg.h"
#ifdef HAVE_LIBENDEAVOUR2
# include <endeavour2.h>
#endif
#include "win.h"


typedef struct _core_struct     core_struct;


/*
 *	Core:
 */
struct _core_struct {

	CfgItem	*cfg_list;

	GdkCursor	*busy_cur,
			*passive_busy_cur,
			*translate_cur;
	gboolean	close_all_windows;
	GList		*win;

#ifdef HAVE_LIBENDEAVOUR2
	EDVContext	*edv_ctx;
#endif

};
#define CORE(p)		((core_struct *)(p))


/*
 *	Configuration Get Macros:
 */
#define CFG_GET_B(_p_)		\
(gboolean)CFGItemListGetValueI(cfg_list, (_p_))
#define CFG_GET_I(_p_)		\
CFGItemListGetValueI(cfg_list, (_p_))
#define CFG_GET_L(_p_)		\
CFGItemListGetValueL(cfg_list, (_p_))
#define CFG_GET_UL(_p_)		\
CFGItemListGetValueUL(cfg_list, (_p_))
#define CFG_GET_S(_p_)		\
CFGItemListGetValueS(cfg_list, (_p_))

/*
 *	Configuration Set Macros:
 */
#define CFG_SET_B(_p_,_v_)	{	\
 CFGItemListSetValueI(			\
  cfg_list, (_p_), (_v_) ? TRUE : FALSE, FALSE \
 ); }
#define CFG_SET_I(_p_,_v_)	{	\
 CFGItemListSetValueI(			\
  cfg_list, (_p_), (_v_), FALSE		\
 ); }
#define CFG_SET_L(_p_,_v_)	{	\
 CFGItemListSetValueL(			\
  cfg_list, (_p_), (_v_), FALSE		\
 ); }
#define CFG_SET_UL(_p_,_v_)	{	\
 CFGItemListSetValueUL(			\
  cfg_list, (_p_), (_v_), FALSE		\
 ); }
#define CFG_SET_S(_p_,_v_)	{	\
 CFGItemListSetValueS(			\
  cfg_list, (_p_), (_v_), FALSE		\
 ); }



/* main.c */
extern win_struct *MainNewImgWorks(
	core_struct *core, gint argc, gchar **argv
);


#endif	/* CORE_H */
